Unit Main;

Interface

Uses
   Winapi.Windows, Winapi.Messages,
   System.SysUtils, System.Variants, System.Classes, System.Diagnostics,
   Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Buttons, Vcl.StdCtrls,
   VaClasses, VaComm;

Const
   SleepTime   = 10;
   TimeOutTime = 5000;

Type
   TMainForm = Class(TForm)
      ComDue: TVaComm;
      LblPort: TLabel;
      CbPort: TComboBox;
      BtnPort: TSpeedButton;
      BtnControl: TSpeedButton;
      LblFrq: TLabel;
      LblDC: TLabel;
      LblVolt: TLabel;
      LblPwmA: TLabel;
      LblPwmB: TLabel;
      EdFrqA: TEdit;
      BtnFrqA: TButton;
      EdFrqB: TEdit;
      BtnFrqB: TButton;
      EdDcB: TEdit;
      BtnDcB: TButton;
      EdDcA: TEdit;
      BtnDcA: TButton;
      EdVoltA: TEdit;
      BtnVoltA: TButton;
      LblSreen: TLabel;
      CbScreen: TComboBox;
      BtnReadScreen: TButton;
      LblAo: TLabel;
      EdAo1: TEdit;
      EdAo2: TEdit;
      EdAo3: TEdit;
      EdAo4: TEdit;
      BtnAo1: TButton;
      BtnAo2: TButton;
      BtnAo3: TButton;
      BtnAo4: TButton;
      BtnAoAll: TButton;
      LblDo: TLabel;
      EdDo: TEdit;
      BtnDo: TButton;
      LblAi: TLabel;
      EdAi1: TEdit;
      EdAi2: TEdit;
      EdAi3: TEdit;
      EdAi4: TEdit;
      BtnAi1: TButton;
      BtnAi2: TButton;
      BtnAi3: TButton;
      BtnAi4: TButton;
      BtnAiAll: TButton;
      LblDi: TLabel;
      EdDi: TEdit;
      BtnDi: TButton;
      MemoLog: TMemo;
      BtnFrqARd: TButton;
      BtnDcARd: TButton;
      BtnVoltARd: TButton;
      BtnFrqBRd: TButton;
      BtnDcBRd: TButton;
      BtnPwmDcRd: TButton;
      BtnPwmAllRd: TButton;
      LblA: TLabel;
      EdOutmodeA: TEdit;
      BtnOutmodeA: TButton;
      BtnOutmodeARd: TButton;
      EdOutmodeB: TEdit;
      BtnOutmodeB: TButton;
      BtnOutmodeBRd: TButton;
      LblB: TLabel;
      LblOutmode: TLabel;
      LblRampNo: TLabel;
      EdRampNoA: TEdit;
      BtnRampNoA: TButton;
      BtnRampNoARd: TButton;
      EdRampNoB: TEdit;
      BtnRampNoB: TButton;
      BtnRampNoBRd: TButton;
      LblRampMode: TLabel;
      EdRampModeA: TEdit;
      BtnRampmodeA: TButton;
      BtnRampmodeARd: TButton;
      EdRampModeB: TEdit;
      BtnRampmodeB: TButton;
      BtnRampmodeBRd: TButton;
      LblRampDur: TLabel;
      EdRampDurTotA: TEdit;
      EdRampDurActA: TEdit;
      EdRampDurTotB: TEdit;
      EdRampDurActB: TEdit;
      BtnDefault: TButton;
      BtnFirmware: TButton;
      LblDefault: TLabel;
      LblFirmware: TLabel;
      EdFirmware: TEdit;
      Procedure FormCreate (Sender: TObject);
      Procedure CbPortDropDown (Sender: TObject);
      Procedure CbPortCloseUp (Sender: TObject);
      Procedure BtnPortClick (Sender: TObject);
      Procedure BtnControlClick (Sender: TObject);
      Procedure EdFrqExit (Sender: TObject);
      Procedure BtnFrqAClick (Sender: TObject);
      Procedure BtnFrqBClick (Sender: TObject);
      Procedure EdDcExit (Sender: TObject);
      Procedure BtnDcAClick (Sender: TObject);
      Procedure BtnDcBClick (Sender: TObject);
      Procedure EdVoltExit (Sender: TObject);
      Procedure BtnVoltAClick (Sender: TObject);
      Procedure CbScreenChange (Sender: TObject);
      Procedure BtnReadScreenClick (Sender: TObject);
      Procedure BtnAoSingleClick (Sender: TObject);
      Procedure BtnAoAllClick (Sender: TObject);
      Procedure EdDoExit (Sender: TObject);
      Procedure BtnDoClick (Sender: TObject);
      Procedure BtnAiSingleClick (Sender: TObject);
      Procedure BtnAiAllClick (Sender: TObject);
      Procedure BtnFrqARdClick (Sender: TObject);
      Procedure BtnDcARdClick (Sender: TObject);
      Procedure BtnVoltARdClick (Sender: TObject);
      Procedure BtnFrqBRdClick (Sender: TObject);
      Procedure BtnDcBRdClick (Sender: TObject);
      Procedure BtnPwmDcRdClick (Sender: TObject);
      Procedure BtnPwmAllRdClick (Sender: TObject);
      Procedure BtnDiClick (Sender: TObject);
      Procedure EdZeroToOne (Sender: TObject);
      Procedure BtnOutmodeAClick (Sender: TObject);
      Procedure BtnOutmodeARdClick (Sender: TObject);
      Procedure BtnOutmodeBClick (Sender: TObject);
      Procedure BtnOutmodeBRdClick (Sender: TObject);
      Procedure BtnRampNoARdClick (Sender: TObject);
      Procedure BtnRampNoBRdClick (Sender: TObject);
      Procedure BtnRampmodeAClick (Sender: TObject);
      Procedure BtnRampmodeARdClick (Sender: TObject);
      Procedure BtnRampmodeBRdClick (Sender: TObject);
      Procedure BtnRampmodeBClick (Sender: TObject);
      Procedure BtnFirmwareClick (Sender: TObject);
      Procedure BtnDefaultClick (Sender: TObject);
      Procedure BtnRampNoAClick (Sender: TObject);
      Procedure EdRampNoExit (Sender: TObject);
      Procedure BtnRampNoBClick (Sender: TObject);
   Private
      { Private-Deklarationen }
      PwmControl: Boolean;
      PortOpen: Boolean;
      StopWatch: TStopWatch;
   Public
      { Public-Deklarationen }
   End;

Var
   MainForm: TMainForm;
   SendText: AnsiString;

Implementation

{$R *.dfm}

Function Translate (Const s: AnsiString): String;
Var
   i: UInt32;
Begin
   Result := '';
   For i := 1 To Length(s) Do
   Begin
      Case s[i] Of
         #2, #3:
         Else
            Result := Result + String(s[i]);
      End;
   End;
End;

Procedure TMainForm.FormCreate (Sender: TObject);
Begin
   PortOpen := False;
   PwmControl := False;
   MemoLog.Clear;
   MemoLog.Lines.Add ('Format der Kommandos:');
   MemoLog.Lines.Add ('STX');
   MemoLog.Lines.Add ('Angezeigter Text');
   MemoLog.Lines.Add ('ETX');
   MemoLog.Lines.Add ('');
End;

Procedure TMainForm.CbPortDropDown (Sender: TObject);
Var
   ComList: TStringList;
Begin
   ComList := TStringList.Create;
   ComDue.GetComPortNames (ComList);
   TComboBox (Sender).Items.Assign (ComList);
   ComList.Free;
End;

Procedure TMainForm.CbPortCloseUp (Sender: TObject);
Var
   ComName: String;
Begin
   ComName := TComboBox (Sender).Items[TComboBox(Sender).ItemIndex];
   If ComName = '' Then
   Begin
      ComDue.PortNum := 0;
      Exit;
   End;
   Delete (ComName, 1, 3);
   ComDue.PortNum := ComName.ToInteger ();
End;

Procedure TMainForm.BtnPortClick (Sender: TObject);
Begin
   PortOpen := TSpeedButton (Sender).Down;
   If PortOpen Then
   Begin
      ComDue.Open;
      TSpeedButton (Sender).Caption := 'Close Port';
   End
   Else
   Begin
      ComDue.Close;
      TSpeedButton (Sender).Caption := 'Open Port';
   End;
End;

Procedure TMainForm.BtnControlClick (Sender: TObject);
Begin
   PwmControl := TSpeedButton (Sender).Down;
   If PwmControl Then
   Begin
      SendText := #2 + 'X' + #3;
      ComDue.WriteText (SendText);
      MemoLog.Lines.Add (Translate(SendText));
      TSpeedButton (Sender).Caption := 'Release PWM';
   End
   Else
   Begin
      SendText := #2 + 'x' + #3;
      ComDue.WriteText (SendText);
      MemoLog.Lines.Add (Translate(SendText));
      TSpeedButton (Sender).Caption := 'Control PWM';
   End;
End;

Procedure TMainForm.EdFrqExit (Sender: TObject);
Var
   Value: Int16;
Begin
   If TEdit (Sender).Text = '' Then
      TEdit (Sender).Text := '100';
   Value := StrToInt (TEdit(Sender).Text);
   If Value < 1 Then
      TEdit (Sender).Text := '1';
   If Value > 5000 Then
      TEdit (Sender).Text := '5000';
End;

Procedure TMainForm.EdRampNoExit (Sender: TObject);
Var
   Value: Int32;
Begin
   Value := StrToInt (TEdit(Sender).Text);
   If Value <= 0 Then
      TEdit (Sender).Text := '0';
   If Value > 20 Then
      TEdit (Sender).Text := '20';
End;

Procedure TMainForm.EdZeroToOne (Sender: TObject);
Var
   Value: Int16;
Begin
   If TEdit (Sender).Text = '' Then
      TEdit (Sender).Text := '0';
   Value := StrToInt (TEdit(Sender).Text);
   If Value < 0 Then
      TEdit (Sender).Text := '0';
   If Value > 1 Then
      TEdit (Sender).Text := '1';
End;

Procedure TMainForm.EdDcExit (Sender: TObject);
Var
   Value: Int16;
Begin
   If TEdit (Sender).Text = '' Then
      TEdit (Sender).Text := '5000';
   Value := StrToInt (TEdit(Sender).Text);
   If Value < 0 Then
      TEdit (Sender).Text := '0';
   If Value > 10000 Then
      TEdit (Sender).Text := '10000';
End;

Procedure TMainForm.EdVoltExit (Sender: TObject);
Var
   Value: Int16;
Begin
   If TEdit (Sender).Text = '' Then
      TEdit (Sender).Text := '120';
   Value := StrToInt (TEdit(Sender).Text);
   If Value < 1 Then
      TEdit (Sender).Text := '1';
   If Value > 150 Then
      TEdit (Sender).Text := '150';
End;

Procedure TMainForm.BtnFirmwareClick (Sender: TObject);
Var
   Data: AnsiString;
Begin
   SendText := #2 + 'i' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= sizeof (UInt8) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < 5) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Byte(s) received');
   Data := ComDue.ReadText ();
   EdFirmware.Text := String(Data);
End;

Procedure TMainForm.BtnFrqAClick (Sender: TObject);
Begin
   SendText := #2 + 'F' + AnsiString (EdFrqA.Text) + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnFrqARdClick (Sender: TObject);
Var
   Data: UInt16;
Begin
   SendText := #2 + 'q1' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= sizeof (UInt16) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < sizeof(UInt16)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (Data, sizeof(UInt16));
   EdFrqA.Text := Data.ToString ();
End;

Procedure TMainForm.BtnFrqBClick (Sender: TObject);
Begin
   SendText := #2 + 'f' + AnsiString (EdFrqB.Text) + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnFrqBRdClick (Sender: TObject);
Var
   Data: UInt16;
Begin
   SendText := #2 + 'q4' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= sizeof (UInt16) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < sizeof(UInt16)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (Data, sizeof(UInt16));
   EdFrqB.Text := Data.ToString ();
End;

Procedure TMainForm.BtnOutmodeAClick (Sender: TObject);
Begin
   If AnsiString (EdOutmodeA.Text) = '1' Then
      SendText := #2 + 'M1' + #3
   Else
      SendText := #2 + 'M3' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnOutmodeARdClick (Sender: TObject);
Var
   Data: UInt8;
Begin
   SendText := #2 + 'm0' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= sizeof (UInt8) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < sizeof(UInt8)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (Data, sizeof(UInt8));
   EdOutmodeA.Text := Data.ToString ();
End;

Procedure TMainForm.BtnOutmodeBClick (Sender: TObject);
Begin
   If AnsiString (EdOutmodeB.Text) = '1' Then
      SendText := #2 + 'M6' + #3
   Else
      SendText := #2 + 'M8' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnOutmodeBRdClick (Sender: TObject);
Var
   Data: UInt8;
Begin
   SendText := #2 + 'm1' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= sizeof (UInt8) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < sizeof(UInt8)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (Data, sizeof(UInt8));
   EdOutmodeB.Text := Data.ToString ();
End;

Procedure TMainForm.BtnDcAClick (Sender: TObject);
Begin
   SendText := #2 + 'D' + AnsiString (EdDcA.Text) + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnDcARdClick (Sender: TObject);
Var
   Data: UInt16;
Begin
   SendText := #2 + 'q2' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= sizeof (UInt16) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < sizeof(UInt16)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (Data, sizeof(UInt16));
   EdDcA.Text := Data.ToString ();
End;

Procedure TMainForm.BtnDcBClick (Sender: TObject);
Begin
   SendText := #2 + 'd' + AnsiString (EdDcB.Text) + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnDcBRdClick (Sender: TObject);
Var
   Data: UInt16;
Begin
   SendText := #2 + 'q5' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= sizeof (UInt16) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < sizeof(UInt16)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (Data, sizeof(UInt16));
   EdDcB.Text := Data.ToString ();
End;

Procedure TMainForm.BtnDefaultClick (Sender: TObject);
Begin
   SendText := #2 + 'I' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnVoltAClick (Sender: TObject);
Begin
   SendText := #2 + 'V' + AnsiString (EdVoltA.Text) + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnVoltARdClick (Sender: TObject);
Var
   Data: UInt16;
Begin
   SendText := #2 + 'q3' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= sizeof (UInt16) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < sizeof(UInt16)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (Data, sizeof(UInt16));
   EdVoltA.Text := Data.ToString ();
End;

Procedure TMainForm.BtnPwmDcRdClick (Sender: TObject);
Var
   Data: Array [0 .. 1] Of UInt16;
Begin
   SendText := #2 + 'q7' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= 2 * sizeof (UInt16) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < 2 * sizeof(UInt16)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (Data, 2 * sizeof(UInt16));
   EdDcA.Text := Data[0].ToString ();
   EdDcB.Text := Data[1].ToString ();
End;

Procedure TMainForm.BtnPwmAllRdClick (Sender: TObject);
Var
   Data: Array [0 .. 5] Of UInt16;
Begin
   SendText := #2 + 'q8' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 1s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= 6 * sizeof (UInt16) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < 6 * sizeof(UInt16)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (Data, 6 * sizeof(UInt16));
   EdFrqA.Text := Data[0].ToString ();
   EdDcA.Text := Data[1].ToString ();
   EdVoltA.Text := Data[2].ToString ();
   EdFrqB.Text := Data[3].ToString ();
   EdDcB.Text := Data[4].ToString ();
   // EdVoltB.Text := Data[0].ToString ();
End;

Procedure TMainForm.CbScreenChange (Sender: TObject);
Begin
   SendText := #2 + 'S' + AnsiString ((TComboBox(Sender).ItemIndex + 1).ToString) + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnRampmodeAClick (Sender: TObject);
Begin
   If AnsiString (EdRampModeA.Text) = '1' Then
      SendText := #2 + 'M2' + #3
   Else
      SendText := #2 + 'M4' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnRampmodeARdClick (Sender: TObject);
Var
   DurTot: UInt32;
   DurAct: UInt32;
Begin
   SendText := #2 + 'm4' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= 2 * sizeof (UInt32) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < 2 * sizeof(UInt32)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (DurTot, sizeof(UInt32));
   ComDue.ReadBuf (DurAct, sizeof(UInt32));
   EdRampDurTotA.Text := DurTot.ToString ();
   EdRampDurActA.Text := DurAct.ToString ();
   If (DurTot > 0) Then
      EdRampModeA.Text := '1'
   Else
      EdRampModeA.Text := '0';
End;

Procedure TMainForm.BtnRampmodeBClick (Sender: TObject);
Begin
   If AnsiString (EdRampModeB.Text) = '1' Then
      SendText := #2 + 'M7' + #3
   Else
      SendText := #2 + 'M9' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnRampmodeBRdClick (Sender: TObject);
Var
   DurTot: UInt32;
   DurAct: UInt32;
Begin
   SendText := #2 + 'm5' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= 2 * sizeof (UInt32) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < 2 * sizeof(UInt32)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (DurTot, sizeof(UInt32));
   ComDue.ReadBuf (DurAct, sizeof(UInt32));
   EdRampDurTotB.Text := DurTot.ToString ();
   EdRampDurActB.Text := DurAct.ToString ();
   If (DurTot > 0) Then
      EdRampModeB.Text := '1'
   Else
      EdRampModeB.Text := '0';
End;

Procedure TMainForm.BtnRampNoAClick (Sender: TObject);
Begin
   SendText := #2 + 'M0' + AnsiString (EdRampNoA.Text) + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnRampNoARdClick (Sender: TObject);
Var
   Data: UInt8;
Begin
   SendText := #2 + 'm2' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= sizeof (UInt8) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < sizeof(UInt8)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (Data, sizeof(UInt8));
   EdRampNoA.Text := Data.ToString ();
End;

Procedure TMainForm.BtnRampNoBClick (Sender: TObject);
Begin
   SendText := #2 + 'M5' + AnsiString (EdRampNoB.Text) + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnRampNoBRdClick (Sender: TObject);
Var
   Data: UInt8;
Begin
   SendText := #2 + 'm3' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= sizeof (UInt8) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < sizeof(UInt8)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (Data, sizeof(UInt8));
   EdRampNoB.Text := Data.ToString ();
End;

Procedure TMainForm.BtnReadScreenClick (Sender: TObject);
Var
   Data: AnsiChar;
Begin
   SendText := #2 + 's' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= sizeof (UInt8) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < sizeof(UInt8)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Byte(s) received');
   ComDue.ReadChar (Data);
   CbScreen.ItemIndex := Ord (Data) - 1;
End;

Procedure TMainForm.BtnAoSingleClick (Sender: TObject);
Var
   CmdStr: AnsiString;
Begin
   Case TButton (Sender).Tag Of
      1:
         CmdStr := 'a1' + AnsiString (EdAo1.Text);
      2:
         CmdStr := 'a2' + AnsiString (EdAo2.Text);
      3:
         CmdStr := 'a3' + AnsiString (EdAo3.Text);
      4:
         CmdStr := 'a4' + AnsiString (EdAo4.Text);
   Else
      Begin
         MemoLog.Lines.Add ('Unknown Command');
         Exit;
      End;
   End;
   SendText := #2 + CmdStr + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnAoAllClick (Sender: TObject);
Begin
   SendText := #2 + 'A' + AnsiString (EdAo1.Text + ';' + EdAo2.Text + ';' + EdAo3.Text + ';' + EdAo4.Text) + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.EdDoExit (Sender: TObject);
Var
   Value: Int16;
Begin
   If TEdit (Sender).Text = '' Then
      TEdit (Sender).Text := '0';
   Value := StrToInt (TEdit(Sender).Text);
   If Value < 0 Then
      TEdit (Sender).Text := '0';
   If Value > 255 Then
      TEdit (Sender).Text := '255';
End;

Procedure TMainForm.BtnDoClick (Sender: TObject);
Begin
   SendText := #2 + 'P' + AnsiString (EdDo.Text) + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));
End;

Procedure TMainForm.BtnAiSingleClick (Sender: TObject);
Var
   Data: Single;
   CmdStr: AnsiString;
Begin
   Data := 0;
   Case TButton (Sender).Tag Of
      1:
         CmdStr := 'r1';
      2:
         CmdStr := 'r2';
      3:
         CmdStr := 'r3';
      4:
         CmdStr := 'r4';
   Else
      Begin
         MemoLog.Lines.Add ('Unknown Command');
         Exit;
      End;
   End;

   SendText := #2 + CmdStr + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= sizeof (Single) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < sizeof(Single)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (Data, sizeof(Single));
   Case TButton (Sender).Tag Of
      1:
         EdAi1.Text := Data.ToString (ffFixed, 0, 3) + ' V';
      2:
         EdAi2.Text := Data.ToString (ffFixed, 0, 3) + ' V';
      3:
         EdAi3.Text := Data.ToString (ffFixed, 0, 3) + ' V';
      4:
         EdAi4.Text := Data.ToString (ffFixed, 0, 3) + ' V';
   End;
End;

Procedure TMainForm.BtnAiAllClick (Sender: TObject);
Var
   Data: Array [0 .. 3] Of Single;
Begin
   SendText := #2 + 'R' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= 4 * sizeof (Single) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < 4 * sizeof(Single)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Bytes received');
   ComDue.ReadBuf (Data, 4 * sizeof(Single));
   EdAi1.Text := Data[0].ToString (ffFixed, 0, 3) + ' V';
   EdAi2.Text := Data[1].ToString (ffFixed, 0, 3) + ' V';
   EdAi3.Text := Data[2].ToString (ffFixed, 0, 3) + ' V';
   EdAi4.Text := Data[3].ToString (ffFixed, 0, 3) + ' V';
End;

Procedure TMainForm.BtnDiClick (Sender: TObject);
Var
   Data: AnsiChar;
Begin
   SendText := #2 + 'B' + #3;
   ComDue.WriteText (SendText);
   MemoLog.Lines.Add (Translate(SendText));

   // Jetzt warten bis Daten da sind (mit Timeout von 5s)
   StopWatch.StartNew;
   Repeat
      Sleep (SleepTime);
      If ComDue.ReadBufUsed >= sizeof (UInt8) Then
         break;
   Until (StopWatch.ElapsedMilliseconds > TimeOutTime);

   If (ComDue.ReadBufUsed < sizeof(UInt8)) Then
   Begin
      MemoLog.Lines.Add ('Timeout while try to read');
      Exit;
   End;

   MemoLog.Lines.Add (ComDue.ReadBufUsed.ToString() + ' Byte(s) received');
   ComDue.ReadChar (Data);
   EdDi.Text := UInt8 (Data).ToString ();
End;

End.
